config/routes.rb
Rails.application.routes.draw do
  resources :dairy_details
  root 'dashboard#index'
  devise_for :users
  resources :customer_payments
  resources :rate_charts
  resources :daily_collections do
    collection do
      get 'payment_register'
      get 'daily_report'
    end
  end
  resources :customers

  get 'rate_by_snf_and_fat', to: 'rate_charts#rate_by_snf_and_fat'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/customer.rb
class Customer < ApplicationRecord
  has_many :daily_collections, dependent: :destroy
  has_many :customer_payments, dependent: :destroy
  belongs_to :user
end

app/controllers/customers_controller.rb
class CustomersController < ApplicationController
  before_action :set_customer, only: [:show, :edit, :update, :destroy]
  load_and_authorize_resource
  # GET /customers
  # GET /customers.json
  def index
    if params[:customer_name]
      @customers = Customer.where("name LIKE '%#{params[:customer_name]}%'")
    else
      @customers = Customer.all
    end

  end

  # GET /customers/1
  # GET /customers/1.json
  def show
  end

  # GET /customers/new
  def new
    @customer = Customer.new
  end

  # GET /customers/1/edit
  def edit
  end

  # POST /customers
  # POST /customers.json
  def create
    @customer = Customer.new(customer_params)
    @customer.user = current_user

    respond_to do |format|
      if @customer.save
        format.html { redirect_to @customer, notice: 'Customer was successfully created.' }
        format.json { render :show, status: :created, location: @customer }
      else
        format.html { render :new }
        format.json { render json: @customer.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /customers/1
  # PATCH/PUT /customers/1.json
  def update
    @customer.user = current_user
    respond_to do |format|
      if @customer.update(customer_params)
        format.html { redirect_to @customer, notice: 'Customer was successfully updated.' }
        format.json { render :show, status: :ok, location: @customer }
      else
        format.html { render :edit }
        format.json { render json: @customer.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /customers/1
  # DELETE /customers/1.json
  def destroy
    @customer.destroy
    respond_to do |format|
      format.html { redirect_to customers_url, notice: 'Customer was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_customer
      @customer = Customer.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def customer_params
      params.require(:customer).permit(:name, :contact, :address, :cattle_type)
    end
end

app/helpers/customers_helper.rb
module CustomersHelper
end

app/views/customers/_form.html.erb
<%= form_with(model: customer, local: true, id: 'new_customer_form') do |form| %>
  <% if customer.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(customer.errors.count, "error") %> prohibited this customer from being saved:</h2>

      <ul>
      <% customer.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group row">
    <%= form.label :name, class: 'col-sm-2 col-form-label' %>
    <div class="col-sm-10">
      <%= form.text_field :name, class: 'form-control', required: true, tabIndex: 1 %>
    </div>
  </div>

  <div class="form-group row">
    <%= form.label :contact, class: 'col-sm-2 col-form-label' %>
    <div class="col-sm-10">
      <%= form.text_field :contact, class: 'form-control', required: true, tabIndex: 2 %>
    </div>
  </div>

  <div class="form-group row">
    <%= form.label :address, class: 'col-sm-2 col-form-label' %>
    <div class="col-sm-10">
      <%= form.text_field :address, class: 'form-control', required: true, tabIndex: 3 %>
    </div>
  </div>

  <div class="form-group row">
    <%= form.label :cattle_type, class: 'col-sm-2 col-form-label' %>
    <div class="col-sm-10">
      <%= form.select :cattle_type, options_for_select(["COW", "BUFFALO"], selected: (@customer.cattle_type unless @customer.nil?)),
                      {include_blank: true }, class: 'form-control',
                      required: true, tabIndex: 4 %>
    </div>
  </div>

  <div class="actions" class="">
    <%= form.submit 'Submit', class: 'btn btn-primary pull-right', tabIndex: 5 %>
  </div>
<% end %>

app/views/customers/edit.html.erb
<div class="row">
  <div class="col-3"></div>
  <div class="col-6">
    <div class="card">
      <h4 class="card-header">
        <%= link_to customers_path, class: 'btn' do %>
          <i class="fa fa-arrow-left"></i>
        <% end %>
        Editing Customer

        <%= link_to 'Show', @customer, class: 'btn btn-secondary pull-right' %>
      </h4>
      <div class="card-body">
        <%= render 'form', customer: @customer %>
      </div>
    </div>
  </div>
  <div class="col-3"></div>
</div>

app/views/customers/index.html.erb
<div class="card">
  <div class="card-header">
    <h4>
      Customers

      <span class="pull-right">
    <%= link_to 'Add new Customer', new_customer_path, class: 'btn btn-primary' %>
  </span>
    </h4>
  </div>
  <div class="card-body">
    <table class="table table-bordered" id="customers_table">
      <thead>
      <tr>
        <th>Name</th>
        <th>Contact</th>
        <th>Address</th>
        <th>Cattle type</th>
        <th>Actions</th>
      </tr>
      </thead>

      <tbody>
      <% @customers.each do |customer| %>
        <tr>
          <td><%= customer.name %></td>
          <td><%= customer.contact %></td>
          <td><%= customer.address %></td>
          <td><%= customer.cattle_type %></td>
          <td>
            <div class="btn-group" role="group" aria-label="Basic example">
              <%= link_to '<i class="fa fa-eye"></i>'.html_safe,
                          customer, class: 'btn btn-primary btn-sm',
                          'data-toggle':"tooltip", 'data-placement': "top",
                          title: "Show details" %>
              <%= link_to '<i class="fa fa-edit"></i>'.html_safe,
                          edit_customer_path(customer),
                          class: 'btn btn-secondary btn-sm', 'data-toggle':"tooltip",
                          'data-placement': "top", title: "Edit Entry" %>
              <%= link_to '<i class="fa fa-trash"></i>'.html_safe,
                          customer, class: 'btn btn-danger btn-sm',
                          method: :delete, data: { confirm: 'Are you sure?' },
                          'data-toggle':"tooltip", 'data-placement': "top",
                          title: "Delete Entry" %>
            </div>
          </td>
        </tr>
      <% end %>
      </tbody>
    </table>
  </div>
</div>

app/views/customers/new.html.erb
<div class="row">
  <div class="col-3"></div>
  <div class="col-6">
    <div class="card">
      <h4 class="card-header">
        <%= link_to customers_path, class: 'btn' do %>
          <i class="fa fa-arrow-left"></i>
        <% end %>
        New Customer
      </h4>
      <div class="card-body">
        <%= render 'form', customer: @customer %>
      </div>
    </div>
  </div>
  <div class="col-3"></div>
</div>

app/views/customers/show.html.erb
<div class="row">
  <div class="col">
    <div class="card" style="height: 30rem; overflow: auto;">
      <span class="card-header">
        <%= link_to '<i class="fa fa-arrow-left"></i>'.html_safe, customers_path,
                    class: 'card-link btn' %>
         Customer Profile
        <span class="pull-right">
          <%= link_to 'Edit', edit_customer_path(@customer), class: 'card-link btn btn-primary' %>
        </span>
      </span>
      <div class="card-body">
        <div class="card">
          <ul class="list-group list-group-flush">
            <li class="list-group-item">
              <strong>Customer Name: </strong><%= @customer.name %>
            </li>
            <li class="list-group-item"><strong>Mobile: </strong><%= @customer.contact %></li>
            <li class="list-group-item"><strong>Address: </strong><%= @customer.address %></li>
            <li class="list-group-item"><strong>Cattle Type: </strong> <%= @customer.cattle_type.capitalize %></li>
            <li class="list-group-item">
              <strong>Total Amount: </strong><%= @customer.daily_collections.sum(&:total_price) %>
            </li>
            <li class="list-group-item">
              <strong>Total Litres: </strong><%= @customer.daily_collections.sum(&:litre) %>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </div>
  <% unless current_user.has_role? :editor %>
    <div class="col">
      <div class="card" style="height: 30rem; overflow: auto;">
        <div class="card-header">
          Payments
          <span class="pull-right">
          <%= link_to 'Make Payment', new_customer_payment_path(customer_id: @customer.id), class: 'card-link btn btn-warning' %>
            Outstanding: &nbsp;
            <% outstanding = @customer.daily_collections.sum(&:total_price) - @customer.customer_payments.sum(&:amount) %>
            <strong style="color: <%= outstanding > 0 ? 'green' : 'red' %>;">
              Rs. <%= outstanding %>
          </strong>
        </span>
        </div>
        <div class="card-body">
          <table class="table table-bordered" style="max-height: 20rem; overflow: auto;" id="customer_payment_history">
            <thead>
            <tr>
              <th>Date</th>
              <th>Amount</th>
              <th>Description</th>
              <th></th>
            </tr>
            </thead>
            <tbody>
            <% if @customer.customer_payments.nil? %>
              <tr>
                <td colspan="3">Nothing Found</td>
              </tr>
            <% else %>
              <% @customer.customer_payments.order("date DESC").each do |payment| %>
                <tr>
                  <td><%= payment.date %></td>
                  <td><%= payment.amount %></td>
                  <td><%= payment.description %></td>
                  <td>
                    <div class="btn-group" role="group" aria-label="Basic example">
                      <%= link_to '<i class="fa fa-print"></i>'.html_safe,
                                  customer_payment_path(payment, format: 'pdf'), class: 'btn btn-info btn-sm',
                                  'data-toggle':"tooltip", 'data-placement': "top",
                                  title: "Print" %>
                      <%= link_to '<i class="fa fa-edit"></i>'.html_safe,
                                  edit_customer_payment_path(payment),
                                  class: 'btn btn-secondary btn-sm', 'data-toggle':"tooltip",
                                  'data-placement': "top", title: "Edit Entry" %>
                      <%= link_to '<i class="fa fa-trash"></i>'.html_safe,
                                  payment, class: 'btn btn-danger btn-sm',
                                  method: :delete, data: { confirm: 'Are you sure?' },
                                  'data-toggle':"tooltip", 'data-placement': "top",
                                  title: "Delete Entry" %>
                    </div>
                  </td>
                </tr>
              <% end %>
            <% end %>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  <% end %>
</div>
<br>
<div class="row">
  <div class="col">
    <div class="card">
      <div class="card-header">
        Collection
      </div>
      <div class="card-body">
        <table class="table table-bordered" style="max-height: 50rem; overflow: auto;" id="customer_milk_collection">
          <thead>
            <tr>
              <th>Date</th>
              <th>Time</th>
              <th>Shift</th>
              <th>Litre</th>
              <th>Fat</th>
              <th>Snf</th>
              <th>Rate</th>
              <th>Total price</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
          <% if @customer.daily_collections.nil? %>
            <tr>
              <td colspan="3">Nothing Found</td>
            </tr>
          <% else %>
            <% @customer.daily_collections.order("date DESC").each do |daily_collection| %>
              <tr>
                <td><%= daily_collection.date %></td>
                <td><%= daily_collection.time.strftime("%I:%M %p") %></td>
                <td><%= daily_collection.shift %></td>
                <td><%= daily_collection.litre %></td>
                <td><%= daily_collection.fat %></td>
                <td><%= daily_collection.snf %></td>
                <td><%= daily_collection.rate %></td>
                <td><%= daily_collection.total_price %></td>
                <td>
                  <div class="btn-group" role="group" aria-label="Basic example">
                    <%= link_to '<i class="fa fa-print"></i>'.html_safe,
                                daily_collection_path(daily_collection, format: 'pdf'),
                                class: 'btn btn-secondary btn-sm', 'data-toggle':"tooltip",
                                'data-placement': "top", title: "Print" %>
                    <%= link_to '<i class="fa fa-eye"></i>'.html_safe,
                                daily_collection, class: 'btn btn-primary btn-sm',
                                'data-toggle':"tooltip", 'data-placement': "top",
                                title: "Show details" %>
                  </div>
                </td>
              </tr>
            <% end %>
          <% end %>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>